create function st_value(rast raster, band integer, pt geometry, exclude_nodata_value boolean DEFAULT true) returns double precision
LANGUAGE plpgsql
AS $$
DECLARE
        x float8;
        y float8;
        gtype text;
    BEGIN
        gtype := public.ST_geometrytype(pt);
        IF ( gtype != 'ST_Point' ) THEN
            RAISE EXCEPTION 'Attempting to get the value of a pixel with a non-point geometry';
        END IF;

				IF public.ST_SRID(pt) != public.ST_SRID(rast) THEN
            RAISE EXCEPTION 'Raster and geometry do not have the same SRID';
				END IF;

        x := public.ST_x(pt);
        y := public.ST_y(pt);
        RETURN public.ST_value(rast,
                        band,
                        public.ST_worldtorastercoordx(rast, x, y),
                        public.ST_worldtorastercoordy(rast, x, y),
                        exclude_nodata_value);
    END;

$$;
